#include "TIOSlib.h"

char InputBuffer[101];

char * gets(char FirstChar)
{
 int c;
 int exit = 0, Rendu = 0;

 CursorY = 15;
 CursorX = 0;

 BufferDisplay(Buffer);
 ClearMsgLine();
 DisplayDoubleBuffer();

 do
 {
    if(!FirstChar)
    {
       while(!kbhit());
       c = ReadKey();
    }
    else
    {
       c = FirstChar;
       FirstChar = 0;
    }

    switch(c)
    {
       case 13   : exit = 1;
                   break;

       case 0x901:
       case 0x101: if(Rendu > 0) InputBuffer[--Rendu] = 0;
                   break;

       default   : if(c <= 255)
                   {
                      if(Rendu < 99) InputBuffer[Rendu++] = c;
                      InputBuffer[Rendu] = 0;
                   }
                   break;
    }

    CursorX = Rendu;

    ClearMsgLine();
    InputBuffer[Rendu] = ' ';
    InputBuffer[Rendu + 1] = 0;
    PlotText(InputBuffer, 15);
    InputBuffer[Rendu] = 0;
    DisplayDoubleBuffer();

 } while(!exit && Rendu);
 return InputBuffer;
}


void *bcopy(void * s, void * d, int n)
{
 return memcpy ((d), (s), (n));
}


void ReturnListFromIntArray(int * Tab, int nb)
{
 int i, t;
 char n;

 RETURN_VAR++;
 *(RETURN_VAR++) = 0xE5;

 for(i = nb - 1 ; i >= 0 ; i--)
 {
  t = Tab[i];
  if(t < 0) t = -t;

  n = 0;
  while(t != 0)
  {
   n++;
   *(RETURN_VAR++) = t & 0xFF;
   t >>= 8;
  }

  *(RETURN_VAR++) = n;
  if(Tab[i] >= 0)
    *(RETURN_VAR++) = 0x1F;
   else
    *(RETURN_VAR++) = 0x20;
 }

 *RETURN_VAR = 0xD9;
}


void ReturnString(char * str)
{
 RETURN_VAR++;
 *(RETURN_VAR++) = 0;
 strncpy(RETURN_VAR, str, 16365); /* EStackSize = 16370 */
 RETURN_VAR += strlen(RETURN_VAR);
 *(RETURN_VAR++) = 0;
 *(RETURN_VAR) = 0x2D;
}


int GetIntParameter(int * param)
{
 unsigned char nb;
 int i;

 char * source = GET_PARAM;
 if(*(source--) != 0x1F)
  return 0; /* Error */

 nb = *(source--);
 *param = 0;
 for(i = 1 ; i <= nb ; i++)
  *param = (*param << 8) + *(source--);
 return 1;
}


int GetStrnParameter(char * str, size_t n)
{
 char * source = GET_PARAM;
 if(*(source--) != 0x2D)
  return 0; /* Error */

 while(*(--source));
 source++;

 strncpy(str, source, n);
 str[n] = 0;
 return 1;
}



int kbhit()
{
 int Retour = 0;

 asm("tst.w 0x75BC;"
     "beq PasTouche;"
     "move.w #1,%0;"
     "PasTouche:;" : "=g" (Retour):);

 return Retour;
}

int ReadKey()
{
 int Retour;

 asm("move.w 0x75BE,%0; clr.w 0x75BC" : "=g" (Retour));

 switch(Retour)
 {
    case 0x205E: Retour = 0x24;
                 break;

 }

 return Retour;
}
