#ifndef buffer__h
#define buffer__h

#include "TIOSlib.h"

typedef struct sLigne
{
 char * Texte;
 int Longueur;
 int Hauteur;
 struct sLigne * LignePrecedente;
 struct sLigne * LigneSuivante;
} tLigne;

typedef struct
{
 int NbLignes;
 int NumLigneCourante;
 tLigne * PremiereLigne;
 int Modified;
} tBuffer;

tBuffer * BufferLoad(char * Texte);

void BufferFree(tBuffer * Buffer);

tLigne * BufferLigne(tBuffer * Buffer, int NumLigne);

void BufferDisplay(tBuffer * Buffer);

tHandle BufferSave(tBuffer * Buffer);

void LigneSupprimerCaractere(tLigne * Ligne, int Position);

void LigneInsererCaractere(tLigne * Ligne, int Position, unsigned char Caractere);

void BufferInsererLigne(tBuffer * Buffer, int NumLigne);

void LigneRemplacerTexte(tLigne * Ligne, char * Texte);

void BufferAjusteHauteur(tBuffer * Buffer);

void LigneStrCat(tLigne * Ligne, char * str);


#endif