#include "TIOSlib.h"
//#include "PlotTxt.h"
#include "buffer.h"
#include "vmode.h"
#include "display.h"
#include "regexp.h"

int SensRecherche;

int CursorX = 0, CursorY = 0;
int CursorChar, CursorLine;
tBuffer * Buffer;
int DispLineNumber;
int QuitProg;

int InputMode = 0, ExtraChar; // pour inserer apres la fin de la ligne

void GoInInputMode();

#define MAX_CHARS 17 /* fldrname\filename */

int _ti92plus;


void CursorFit()
{
 int i, CursorYIni = 0, Len, Len0;
 tLigne * Ligne = BufferLigne(Buffer, CursorLine);
 tLigne * LigneCourante;
 int CursorCharTmp = CursorChar + (DispLineNumber?5:0);

 Len0 = Ligne->Longueur;
 Len = Len0+ (DispLineNumber?5:0);
 if(CursorCharTmp > Len)
 {
    if(!(InputMode && ExtraChar)) 
      CursorX = Len - 1;
    else
      CursorX = Len;  
 }
 else
    CursorX = CursorCharTmp - 1;

 if(Len0 == 0) CursorX = 0 + (DispLineNumber?5:0); // pour le cas ou la ligne est vide

 while(CursorX > 39)
 {
  CursorX -= 40;
  CursorYIni++;
 }


 while(Buffer->NumLigneCourante > CursorLine) Buffer->NumLigneCourante--;


 Buffer->NumLigneCourante--;
 if(Buffer->NumLigneCourante + 15 < CursorLine) Buffer->NumLigneCourante = CursorLine - 16;
 do
 {
  Buffer->NumLigneCourante++;
  LigneCourante = BufferLigne(Buffer, Buffer->NumLigneCourante);
  CursorY = CursorYIni;
  for(i = Buffer->NumLigneCourante ; i < CursorLine ; i++)
  {
   CursorY += LigneCourante->Hauteur;
   LigneCourante = LigneCourante->LigneSuivante;
  }
 } while(CursorY > 15);

}

void _main()
{
 char * str = (char *)malloc((MAX_CHARS + 2) * sizeof(char)); /* 0 avant et aprs */
 unsigned char * Fichier;
 FolderEntry * Entry;

 previous = NULL; // previous regexp
 errorhandler = (jmp_buf *)malloc(sizeof(jmp_buf));

 *(str++) = 0; /* 0 initial */

 if(!GetStrnParameter(str, MAX_CHARS)) /* Rcupre le nom du fichier */
 {
  ReturnString("Syntaxe : vi92(NomFichier)");
  return;
 }

 if(!(Entry = SymFindPtr(str + strlen(str), 0))) /* Rcupre l'entre de la FAT correspondante */
 {
  ReturnString("Erreur : fichier non trouve");
  return;
 }

 if(!(Fichier = HeapDeref(Entry->Handle))) /* Rcupre l'adresse du fichier */
 {
  ReturnString("Erreur : fichier non trouve");
  return;
 }

 if(*(Fichier + 1 + *((unsigned int *)Fichier)) != (unsigned char) 0xE0) /* Vrifie s'il s'agit bien d'un TEXT */
 {
  ReturnString("Erreur : pas un fichier TEXT");
  return;
 }


 Buffer = BufferLoad(Fichier + 4);
 InitDisplay();
 InputMode = 0;
 ExtraChar = 0;
 DispLineNumber = 0;
 QuitProg = 0;

 GoInVisualMode();

 FreeDisplay();

 BufferFree(Buffer);
 free(--str);
 free(errorhandler);
}






void regerror(char * str)
{
 ClearMsgLine();
 PlotText(str, 15);
 DisplayDoubleBuffer();
 while(!kbhit());
 ReadKey();
}



void search(tBuffer * Buffer, regexp * RegularExpression, int SensRecherche)
{
 tLigne * LigneCourante, * LineFound;
 int NumLigneCourante, NumLineFound;
 int o = 0, exit = 0, wrapped = 0;
 int NbLignes = Buffer->NbLignes;



 if(!SensRecherche) // VersAvant
 {
    NumLigneCourante = CursorLine + 1;
    if(NumLigneCourante <= Buffer->NbLignes)
       LigneCourante = BufferLigne(Buffer, NumLigneCourante);
    else
    {
       LigneCourante = BufferLigne(Buffer, 1);
       NumLigneCourante = 1;
       wrapped = 1;
    }

    while(!(wrapped && (NumLigneCourante > CursorLine)) && !o)
    {
       o = regexec(RegularExpression, LigneCourante->Texte, 1);
       NumLineFound = NumLigneCourante;
       LineFound = LigneCourante;

       LigneCourante = LigneCourante->LigneSuivante;
       NumLigneCourante++;

      if(!LigneCourante && !wrapped)
       {
          NumLigneCourante = 1;
          LigneCourante = Buffer->PremiereLigne;
          wrapped = 1;
       }
    }

    if(o)
    {
       CursorLine = NumLineFound;
       CursorChar = RegularExpression->startp[0] - LineFound->Texte + 1;
    }
 }
 else
 {
    NumLigneCourante = CursorLine - 1;
    if(NumLigneCourante >= 1)
       LigneCourante = BufferLigne(Buffer, NumLigneCourante);
    else
    {
       LigneCourante = BufferLigne(Buffer, NbLignes);
       NumLigneCourante = NbLignes;
       wrapped = 1;
    }

    while(!(wrapped && (NumLigneCourante < CursorLine)) && !o)
    {
       o = regexec(RegularExpression, LigneCourante->Texte, 1);
       NumLineFound = NumLigneCourante;
       LineFound = LigneCourante;

       LigneCourante = LigneCourante->LignePrecedente;
       NumLigneCourante--;

      if(!LigneCourante && !wrapped)
       {
          NumLigneCourante = NbLignes;
          LigneCourante = BufferLigne(Buffer, NbLignes);
          wrapped = 1;
       }
    }

    if(o)
    {
       CursorLine = NumLineFound;
       CursorChar = RegularExpression->startp[0] - LineFound->Texte + 1;
    }
 }
}