#include "buffer.h"
#include "regexp.h"
#include "vi92.h"
#include "exmode.h"

void GoInVisualMode()
{
 int exit = 0, key, Len;
 tLigne * LigneCurseur;
 char * str;
 regexp * RegularExpression = NULL;

 CursorChar = CursorLine = 1;
 do
 {
  CursorFit();
  BufferDisplay(Buffer);
  while(!kbhit());
  key = ReadKey();
  switch(key)
  {
   // Code temporaire pour quitter en attendant le mode ex
//   case 0x108: exit = 1; break; /* esc */


   case 0x958: // Deplacement curseur vers le bas
   case 0x158: if(CursorLine < Buffer->NbLignes) CursorLine++;
               break;
   case 0x952: // Deplacement curseur vers le haut
   case 0x152: if(CursorLine > 1) CursorLine--;
               break;
   case 0x954: // Deplacement curseur vers la droite
   case 0x154: if(CursorChar < BufferLigne(Buffer, CursorLine)->Longueur) CursorChar++;
               break;
   case 0x951: // Deplacement curseur vers la gauche
   case 0x151: if(CursorChar > 1) CursorChar--;
               Len = BufferLigne(Buffer, CursorLine)->Longueur;
               if(CursorChar > Len) CursorChar = Len - 1;
               if(CursorChar <= 0) CursorChar = 1;
               break;

   case 0x2042: // Diamant + b
               CursorLine -= 14;
               if(CursorLine < 1) CursorLine = 1;
               break;
   case 0x2044: // Diamant + d
               CursorLine += 8;
               if(CursorLine > Buffer->NbLignes) CursorLine = Buffer->NbLignes;
               break;
   case 0x2046: // Diamant + f
               CursorLine += 14;
               if(CursorLine > Buffer->NbLignes) CursorLine = Buffer->NbLignes;
               break;

   case 'a':   GoInInputMode(1);
               break;
   case 'd':   while(!kbhit());
               key = ReadKey();
               if(key == 'd')
                  BufferSupprimerLigne(Buffer, CursorLine);
               if(CursorLine > Buffer->NbLignes) CursorLine = Buffer->NbLignes;
               break;
   case 'i':   GoInInputMode(0);
               break;
   case 'n':   RegularExpression = regcomp(NULL);
               search(Buffer, RegularExpression, SensRecherche);
               break;
   case 'N':   RegularExpression = regcomp(NULL);
               search(Buffer, RegularExpression, !SensRecherche);
               break;
   case 'o':   BufferInsererLigne(Buffer, CursorLine);
               CursorLine++;
               GoInInputMode(0);
               break;
   case 'O':   BufferInsererLigne(Buffer, CursorLine - 1);
               GoInInputMode(0);
               break;
   case 'r':   while(!kbhit());
               key = ReadKey();
               if(key <= 255) // On ajuste d'abord CursorChar
               {
                  LigneCurseur = BufferLigne(Buffer, CursorLine);
                  Len = LigneCurseur->Longueur;
                  if(CursorChar > Len) CursorChar = Len;
                  LigneSupprimerCaractere(LigneCurseur, CursorChar);
                  LigneInsererCaractere(LigneCurseur, CursorChar, key);
               }
               break;
   case 'x':   LigneCurseur = BufferLigne(Buffer, CursorLine);
               Len = LigneCurseur->Longueur;
               if(CursorChar > Len) CursorChar = Len;
               LigneSupprimerCaractere(LigneCurseur, CursorChar);
               if(CursorChar > Len - 1) CursorChar = Len - 1;
               if(CursorChar <= 0) CursorChar = 1;
               break;

   case 'J':   LigneCurseur = BufferLigne(Buffer, CursorLine);
               if(LigneCurseur->LigneSuivante)
               {
                  LigneStrCat(LigneCurseur, LigneCurseur->LigneSuivante->Texte);
                  BufferSupprimerLigne(Buffer, CursorLine + 1);
               }
               break;

   case '/':   str = gets(key);
               if(str[0] == '/')
               {
                  RegularExpression = regcomp(str + 1);
                  SensRecherche = VersAvant;
                  search(Buffer, RegularExpression, SensRecherche);
               }
               break;

   case '?':   str = gets(key);
               if(str[0] == '?')
               {
                  RegularExpression = regcomp(str + 1);
                  SensRecherche = VersArriere;
                  search(Buffer, RegularExpression, SensRecherche);
               }
               break;

   case ':':   GoInExmode();
               break;

   case '^':   CursorChar = 1;
               break;

   case '$':   LigneCurseur = BufferLigne(Buffer, CursorLine);
               Len = LigneCurseur->Longueur;
               CursorChar = Len;
               if(CursorChar <= 0) CursorChar = 1;
               break;
  }

 if(QuitProg) exit = 1;

 } while(!exit);

}
